git-filter-branch.shon commit commit: allow partial commits with relative paths (86238e0)
   1#!/bin/sh
   2#
   3# Rewrite revision history
   4# Copyright (c) Petr Baudis, 2006
   5# Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
   6#
   7# Lets you rewrite the revision history of the current branch, creating
   8# a new branch. You can specify a number of filters to modify the commits,
   9# files and trees.
  10
  11# The following functions will also be available in the commit filter:
  12
  13functions=$(cat << \EOF
  14warn () {
  15        echo "$*" >&2
  16}
  17
  18map()
  19{
  20        # if it was not rewritten, take the original
  21        if test -r "$workdir/../map/$1"
  22        then
  23                cat "$workdir/../map/$1"
  24        else
  25                echo "$1"
  26        fi
  27}
  28
  29# if you run 'skip_commit "$@"' in a commit filter, it will print
  30# the (mapped) parents, effectively skipping the commit.
  31
  32skip_commit()
  33{
  34        shift;
  35        while [ -n "$1" ];
  36        do
  37                shift;
  38                map "$1";
  39                shift;
  40        done;
  41}
  42
  43# if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
  44# it will skip commits that leave the tree untouched, commit the other.
  45git_commit_non_empty_tree()
  46{
  47        if test $# = 3 && test "$1" = $(git rev-parse "$3^{tree}"); then
  48                map "$3"
  49        elif test $# = 1 && test "$1" = 4b825dc642cb6eb9a060e54bf8d69288fbee4904; then
  50                :
  51        else
  52                git commit-tree "$@"
  53        fi
  54}
  55# override die(): this version puts in an extra line break, so that
  56# the progress is still visible
  57
  58die()
  59{
  60        echo >&2
  61        echo "$*" >&2
  62        exit 1
  63}
  64EOF
  65)
  66
  67eval "$functions"
  68
  69finish_ident() {
  70        # Ensure non-empty id name.
  71        echo "case \"\$GIT_$1_NAME\" in \"\") GIT_$1_NAME=\"\${GIT_$1_EMAIL%%@*}\" && export GIT_$1_NAME;; esac"
  72        # And make sure everything is exported.
  73        echo "export GIT_$1_NAME"
  74        echo "export GIT_$1_EMAIL"
  75        echo "export GIT_$1_DATE"
  76}
  77
  78set_ident () {
  79        parse_ident_from_commit author AUTHOR committer COMMITTER
  80        finish_ident AUTHOR
  81        finish_ident COMMITTER
  82}
  83
  84USAGE="[--setup <command>] [--env-filter <command>]
  85        [--tree-filter <command>] [--index-filter <command>]
  86        [--parent-filter <command>] [--msg-filter <command>]
  87        [--commit-filter <command>] [--tag-name-filter <command>]
  88        [--subdirectory-filter <directory>] [--original <namespace>]
  89        [-d <directory>] [-f | --force]
  90        [--] [<rev-list options>...]"
  91
  92OPTIONS_SPEC=
  93. git-sh-setup
  94
  95if [ "$(is_bare_repository)" = false ]; then
  96        require_clean_work_tree 'rewrite branches'
  97fi
  98
  99tempdir=.git-rewrite
 100filter_setup=
 101filter_env=
 102filter_tree=
 103filter_index=
 104filter_parent=
 105filter_msg=cat
 106filter_commit=
 107filter_tag_name=
 108filter_subdir=
 109orig_namespace=refs/original/
 110force=
 111prune_empty=
 112remap_to_ancestor=
 113while :
 114do
 115        case "$1" in
 116        --)
 117                shift
 118                break
 119                ;;
 120        --force|-f)
 121                shift
 122                force=t
 123                continue
 124                ;;
 125        --remap-to-ancestor)
 126                # deprecated ($remap_to_ancestor is set now automatically)
 127                shift
 128                remap_to_ancestor=t
 129                continue
 130                ;;
 131        --prune-empty)
 132                shift
 133                prune_empty=t
 134                continue
 135                ;;
 136        -*)
 137                ;;
 138        *)
 139                break;
 140        esac
 141
 142        # all switches take one argument
 143        ARG="$1"
 144        case "$#" in 1) usage ;; esac
 145        shift
 146        OPTARG="$1"
 147        shift
 148
 149        case "$ARG" in
 150        -d)
 151                tempdir="$OPTARG"
 152                ;;
 153        --setup)
 154                filter_setup="$OPTARG"
 155                ;;
 156        --env-filter)
 157                filter_env="$OPTARG"
 158                ;;
 159        --tree-filter)
 160                filter_tree="$OPTARG"
 161                ;;
 162        --index-filter)
 163                filter_index="$OPTARG"
 164                ;;
 165        --parent-filter)
 166                filter_parent="$OPTARG"
 167                ;;
 168        --msg-filter)
 169                filter_msg="$OPTARG"
 170                ;;
 171        --commit-filter)
 172                filter_commit="$functions; $OPTARG"
 173                ;;
 174        --tag-name-filter)
 175                filter_tag_name="$OPTARG"
 176                ;;
 177        --subdirectory-filter)
 178                filter_subdir="$OPTARG"
 179                remap_to_ancestor=t
 180                ;;
 181        --original)
 182                orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
 183                ;;
 184        *)
 185                usage
 186                ;;
 187        esac
 188done
 189
 190case "$prune_empty,$filter_commit" in
 191,)
 192        filter_commit='git commit-tree "$@"';;
 193t,)
 194        filter_commit="$functions;"' git_commit_non_empty_tree "$@"';;
 195,*)
 196        ;;
 197*)
 198        die "Cannot set --prune-empty and --commit-filter at the same time"
 199esac
 200
 201case "$force" in
 202t)
 203        rm -rf "$tempdir"
 204;;
 205'')
 206        test -d "$tempdir" &&
 207                die "$tempdir already exists, please remove it"
 208esac
 209orig_dir=$(pwd)
 210mkdir -p "$tempdir/t" &&
 211tempdir="$(cd "$tempdir"; pwd)" &&
 212cd "$tempdir/t" &&
 213workdir="$(pwd)" ||
 214die ""
 215
 216# Remove tempdir on exit
 217trap 'cd "$orig_dir"; rm -rf "$tempdir"' 0
 218
 219ORIG_GIT_DIR="$GIT_DIR"
 220ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
 221ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
 222GIT_WORK_TREE=.
 223export GIT_DIR GIT_WORK_TREE
 224
 225# Make sure refs/original is empty
 226git for-each-ref > "$tempdir"/backup-refs || exit
 227while read sha1 type name
 228do
 229        case "$force,$name" in
 230        ,$orig_namespace*)
 231                die "Cannot create a new backup.
 232A previous backup already exists in $orig_namespace
 233Force overwriting the backup with -f"
 234        ;;
 235        t,$orig_namespace*)
 236                git update-ref -d "$name" $sha1
 237        ;;
 238        esac
 239done < "$tempdir"/backup-refs
 240
 241# The refs should be updated if their heads were rewritten
 242git rev-parse --no-flags --revs-only --symbolic-full-name \
 243        --default HEAD "$@" > "$tempdir"/raw-heads || exit
 244sed -e '/^^/d' "$tempdir"/raw-heads >"$tempdir"/heads
 245
 246test -s "$tempdir"/heads ||
 247        die "You must specify a ref to rewrite."
 248
 249GIT_INDEX_FILE="$(pwd)/../index"
 250export GIT_INDEX_FILE
 251
 252# map old->new commit ids for rewriting parents
 253mkdir ../map || die "Could not create map/ directory"
 254
 255# we need "--" only if there are no path arguments in $@
 256nonrevs=$(git rev-parse --no-revs "$@") || exit
 257if test -z "$nonrevs"
 258then
 259        dashdash=--
 260else
 261        dashdash=
 262        remap_to_ancestor=t
 263fi
 264
 265git rev-parse --revs-only "$@" >../parse
 266
 267case "$filter_subdir" in
 268"")
 269        eval set -- "$(git rev-parse --sq --no-revs "$@")"
 270        ;;
 271*)
 272        eval set -- "$(git rev-parse --sq --no-revs "$@" $dashdash \
 273                "$filter_subdir")"
 274        ;;
 275esac
 276
 277git rev-list --reverse --topo-order --default HEAD \
 278        --parents --simplify-merges --stdin "$@" <../parse >../revs ||
 279        die "Could not get the commits"
 280commits=$(wc -l <../revs | tr -d " ")
 281
 282test $commits -eq 0 && die "Found nothing to rewrite"
 283
 284# Rewrite the commits
 285report_progress ()
 286{
 287        if test -n "$progress" &&
 288                test $git_filter_branch__commit_count -gt $next_sample_at
 289        then
 290                count=$git_filter_branch__commit_count
 291
 292                now=$(date +%s)
 293                elapsed=$(($now - $start_timestamp))
 294                remaining=$(( ($commits - $count) * $elapsed / $count ))
 295                if test $elapsed -gt 0
 296                then
 297                        next_sample_at=$(( ($elapsed + 1) * $count / $elapsed ))
 298                else
 299                        next_sample_at=$(($next_sample_at + 1))
 300                fi
 301                progress=" ($elapsed seconds passed, remaining $remaining predicted)"
 302        fi
 303        printf "\rRewrite $commit ($count/$commits)$progress    "
 304}
 305
 306git_filter_branch__commit_count=0
 307
 308progress= start_timestamp=
 309if date '+%s' 2>/dev/null | grep -q '^[0-9][0-9]*$'
 310then
 311        next_sample_at=0
 312        progress="dummy to ensure this is not empty"
 313        start_timestamp=$(date '+%s')
 314fi
 315
 316if test -n "$filter_index" ||
 317   test -n "$filter_tree" ||
 318   test -n "$filter_subdir"
 319then
 320        need_index=t
 321else
 322        need_index=
 323fi
 324
 325eval "$filter_setup" < /dev/null ||
 326        die "filter setup failed: $filter_setup"
 327
 328while read commit parents; do
 329        git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
 330
 331        report_progress
 332
 333        case "$filter_subdir" in
 334        "")
 335                if test -n "$need_index"
 336                then
 337                        GIT_ALLOW_NULL_SHA1=1 git read-tree -i -m $commit
 338                fi
 339                ;;
 340        *)
 341                # The commit may not have the subdirectory at all
 342                err=$(GIT_ALLOW_NULL_SHA1=1 \
 343                      git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
 344                        if ! git rev-parse -q --verify $commit:"$filter_subdir"
 345                        then
 346                                rm -f "$GIT_INDEX_FILE"
 347                        else
 348                                echo >&2 "$err"
 349                                false
 350                        fi
 351                }
 352        esac || die "Could not initialize the index"
 353
 354        GIT_COMMIT=$commit
 355        export GIT_COMMIT
 356        git cat-file commit "$commit" >../commit ||
 357                die "Cannot read commit $commit"
 358
 359        eval "$(set_ident <../commit)" ||
 360                die "setting author/committer failed for commit $commit"
 361        eval "$filter_env" < /dev/null ||
 362                die "env filter failed: $filter_env"
 363
 364        if [ "$filter_tree" ]; then
 365                git checkout-index -f -u -a ||
 366                        die "Could not checkout the index"
 367                # files that $commit removed are now still in the working tree;
 368                # remove them, else they would be added again
 369                git clean -d -q -f -x
 370                eval "$filter_tree" < /dev/null ||
 371                        die "tree filter failed: $filter_tree"
 372
 373                (
 374                        git diff-index -r --name-only --ignore-submodules $commit -- &&
 375                        git ls-files --others
 376                ) > "$tempdir"/tree-state || exit
 377                git update-index --add --replace --remove --stdin \
 378                        < "$tempdir"/tree-state || exit
 379        fi
 380
 381        eval "$filter_index" < /dev/null ||
 382                die "index filter failed: $filter_index"
 383
 384        parentstr=
 385        for parent in $parents; do
 386                for reparent in $(map "$parent"); do
 387                        case "$parentstr " in
 388                        *" -p $reparent "*)
 389                                ;;
 390                        *)
 391                                parentstr="$parentstr -p $reparent"
 392                                ;;
 393                        esac
 394                done
 395        done
 396        if [ "$filter_parent" ]; then
 397                parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
 398                                die "parent filter failed: $filter_parent"
 399        fi
 400
 401        {
 402                while IFS='' read -r header_line && test -n "$header_line"
 403                do
 404                        # skip header lines...
 405                        :;
 406                done
 407                # and output the actual commit message
 408                cat
 409        } <../commit |
 410                eval "$filter_msg" > ../message ||
 411                        die "msg filter failed: $filter_msg"
 412
 413        if test -n "$need_index"
 414        then
 415                tree=$(git write-tree)
 416        else
 417                tree=$(git rev-parse "$commit^{tree}")
 418        fi
 419        workdir=$workdir @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
 420                "$tree" $parentstr < ../message > ../map/$commit ||
 421                        die "could not write rewritten commit"
 422done <../revs
 423
 424# If we are filtering for paths, as in the case of a subdirectory
 425# filter, it is possible that a specified head is not in the set of
 426# rewritten commits, because it was pruned by the revision walker.
 427# Ancestor remapping fixes this by mapping these heads to the unique
 428# nearest ancestor that survived the pruning.
 429
 430if test "$remap_to_ancestor" = t
 431then
 432        while read ref
 433        do
 434                sha1=$(git rev-parse "$ref"^0)
 435                test -f "$workdir"/../map/$sha1 && continue
 436                ancestor=$(git rev-list --simplify-merges -1 "$ref" "$@")
 437                test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
 438        done < "$tempdir"/heads
 439fi
 440
 441# Finally update the refs
 442
 443_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 444_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
 445echo
 446while read ref
 447do
 448        # avoid rewriting a ref twice
 449        test -f "$orig_namespace$ref" && continue
 450
 451        sha1=$(git rev-parse "$ref"^0)
 452        rewritten=$(map $sha1)
 453
 454        test $sha1 = "$rewritten" &&
 455                warn "WARNING: Ref '$ref' is unchanged" &&
 456                continue
 457
 458        case "$rewritten" in
 459        '')
 460                echo "Ref '$ref' was deleted"
 461                git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
 462                        die "Could not delete $ref"
 463        ;;
 464        $_x40)
 465                echo "Ref '$ref' was rewritten"
 466                if ! git update-ref -m "filter-branch: rewrite" \
 467                                        "$ref" $rewritten $sha1 2>/dev/null; then
 468                        if test $(git cat-file -t "$ref") = tag; then
 469                                if test -z "$filter_tag_name"; then
 470                                        warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
 471                                        warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
 472                                fi
 473                        else
 474                                die "Could not rewrite $ref"
 475                        fi
 476                fi
 477        ;;
 478        *)
 479                # NEEDSWORK: possibly add -Werror, making this an error
 480                warn "WARNING: '$ref' was rewritten into multiple commits:"
 481                warn "$rewritten"
 482                warn "WARNING: Ref '$ref' points to the first one now."
 483                rewritten=$(echo "$rewritten" | head -n 1)
 484                git update-ref -m "filter-branch: rewrite to first" \
 485                                "$ref" $rewritten $sha1 ||
 486                        die "Could not rewrite $ref"
 487        ;;
 488        esac
 489        git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
 490                 exit
 491done < "$tempdir"/heads
 492
 493# TODO: This should possibly go, with the semantics that all positive given
 494#       refs are updated, and their original heads stored in refs/original/
 495# Filter tags
 496
 497if [ "$filter_tag_name" ]; then
 498        git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
 499        while read sha1 type ref; do
 500                ref="${ref#refs/tags/}"
 501                # XXX: Rewrite tagged trees as well?
 502                if [ "$type" != "commit" -a "$type" != "tag" ]; then
 503                        continue;
 504                fi
 505
 506                if [ "$type" = "tag" ]; then
 507                        # Dereference to a commit
 508                        sha1t="$sha1"
 509                        sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
 510                fi
 511
 512                [ -f "../map/$sha1" ] || continue
 513                new_sha1="$(cat "../map/$sha1")"
 514                GIT_COMMIT="$sha1"
 515                export GIT_COMMIT
 516                new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
 517                        die "tag name filter failed: $filter_tag_name"
 518
 519                echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
 520
 521                if [ "$type" = "tag" ]; then
 522                        new_sha1=$( ( printf 'object %s\ntype commit\ntag %s\n' \
 523                                                "$new_sha1" "$new_ref"
 524                                git cat-file tag "$ref" |
 525                                sed -n \
 526                                    -e '1,/^$/{
 527                                          /^object /d
 528                                          /^type /d
 529                                          /^tag /d
 530                                        }' \
 531                                    -e '/^-----BEGIN PGP SIGNATURE-----/q' \
 532                                    -e 'p' ) |
 533                                git mktag) ||
 534                                die "Could not create new tag object for $ref"
 535                        if git cat-file tag "$ref" | \
 536                           sane_grep '^-----BEGIN PGP SIGNATURE-----' >/dev/null 2>&1
 537                        then
 538                                warn "gpg signature stripped from tag object $sha1t"
 539                        fi
 540                fi
 541
 542                git update-ref "refs/tags/$new_ref" "$new_sha1" ||
 543                        die "Could not write tag $new_ref"
 544        done
 545fi
 546
 547cd "$orig_dir"
 548rm -rf "$tempdir"
 549
 550trap - 0
 551
 552unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
 553test -z "$ORIG_GIT_DIR" || {
 554        GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
 555}
 556test -z "$ORIG_GIT_WORK_TREE" || {
 557        GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
 558        export GIT_WORK_TREE
 559}
 560test -z "$ORIG_GIT_INDEX_FILE" || {
 561        GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
 562        export GIT_INDEX_FILE
 563}
 564
 565if [ "$(is_bare_repository)" = false ]; then
 566        git read-tree -u -m HEAD || exit
 567fi
 568
 569exit 0